--$Name:Виолетта$
--$Version: 1.0$
-- $Author: Ordos$

instead_version '2.3.0'

require 'modules/fonts'
require 'modules/paginator'
require 'modules/vn'
require 'dash'

dofile "data/game.lua"

if theme:name() ~= '.' then
	error "Пожалуйста, включите собственные темы для игр!"
end

f1 = font('fonts/{sans,sans-b,sans-i}.ttf', 18);
f2 = sprite.font('fonts/font-n.ttf', 50);
f3 = sprite.font('fonts/font-n.ttf', 25);

function pname(n, c)
	return function()
		pn(img 'blank:4x4',f1:txt(n, c, 1))
	end
end

girl = pname("Девочка", "cyan")
ya = pname("Папа", "lightblue")

paginator.delim = '\n[ \t]*\n' -- выбор разделителя для переноса на разные страницы

stead.scene_delim = '^^'

function exec(s) -- вставки кода в вывод
	p('$'..s:gsub("\n", "^")..'$^^')
end


function init()
	vn.fading = 8
	vn:scene ('images/logo2.jpg');
	vn:start 'dissolve';
	txt_title = sprite.text(f2, "Виолетта", 'white')
	txt_ordos_presents = sprite.text(f3, "Великий сказочник Ordos представляет", 'white')
	txt_good_history = sprite.text(f3, "Добрую сказку для детей и их родителей", 'white')
	spr_end = sprite.text(f2, "КОНЕЦ", 'white')
	vn.textboxw = 800
	vn.textboxh = 120
	girl_image = image ('девочка', './images/girl.png')
end


main = vnr {
	dsc = function (s)
		exec [[
			vn:show(txt_ordos_presents, 'fadein-center-middle@-8,0', 5000);
			vn:start ('fading')
		]];
		exec [[
			vn:hide(txt_ordos_presents, 'fadeout', 3000);
			vn:start ('fading')
		]];
		exec [[
			vn:show(txt_good_history, 'fadein-center-middle@-8,0', 5000);
			vn:start ('fading')
		]];
		exec [[
			vn:hide(txt_good_history, 'fadeout', 3000);
			vn:start ('fading')
		]];
		exec [[
			vn:show(txt_title, 'fadein-center-middle@-8,0', 8000);
			vn:start ('fading')
		]];
		exec [[
			vn:hide(txt_title, 'fadeout', 4000);
			vn:start ('fading')
		]];
		pn "Щелкните мышью, чтобы продолжить..."
		pn ()
	end;
	walk_to = 'dialog_game';
};


dialog_game = dlg {
	nam = 'диалог';
	phr = {
		{always = true, 'Начать игру',
		 code = [[ walk 'intro' ]];
		},
		{always = true, 'Информация',
		 code = [[ walk 'info' ]];
		},
	};
};


info = vnr {
	dsc = function (s)
		pn "Эта сказка написана на движке instead в жанре 'визуальной новеллы'."
		pn ()
		pn "Здесь вы не найдете никаких квестов -- это просто сказка. Добрая детская сказка."
		pn ()
		pn "Все изображения взяты из открытых источников под свободными лицензиями."
		pn ()
		pn "Музыка -- Сергей Ковчик. Сайт -- http://kovchik.narod.ru/"
		pn ()
	end,
	walk_to = 'main';
};
